CSP-S2026 游记

· · 生活·游记

在这场绚烂而无人问津的旅行

我相信 再羸弱的花也会睁开眼睛

再淋漓的凉雨 呐喊也有回音

卖不出的歌曲 仍象征希冀

追逐着 梦想着 继续

也是在高二的 CSP-S,打出目前所有 CSP 中第二烂的一场了(最烂的是CSP-S2023)。

那么,还是为 OI 生涯的最后一场 CSP 做个总结吧。

Day -3

大手子 Rain_chr 组了一套模拟赛。

没能拿到任何非平凡分数。

T4 理论上还有个回滚莫队的部分分是在我射程范围内的,但太久没写莫队了,所以没想到。

Day -2

还有场联考得打.jpg

然后再次因为做法猜错,没能通过 T2。

成功的比大众分低了 100+ pts。

其实这个时候感觉心态有点炸了。

Day -1

紧张和焦虑共同作用的结果,导致这天完全难以集中注意力。

下午思考了一下后,决定调整心态,稍微列了一下提高组考纲里的所有算法,顺带复习了下 Kruskal 重构树。

理论上这次如果再考 replace 那种板子,应该是不会忘记 ACAM 在考纲里了(虽然去年最后神秘分块冲过去了)

Day 0.5

毕竟是下午考试,上午休息。

睡到了 10:30,醒来,严肃认为下午考试上午不能再打摆,又怕写不出来题红温,于是选择下楼走走。

然后走了应该是有几公里,看到一个理工大学的标志,大为震惊。

我总不能走到考点附近了吧.jpg

事实上下午过去发现确实,走到了一半往上的路程。

然后感觉调整下心态还是有用的,买了点零食。

Day 1

14:00 进考场,打了缺省源。

欸我草,这个键盘怎么,要么放在桌子里面,要么压住数据线啊。

但好像所有键盘都是这个样子,设计如此.jpg

然后开题,T1 不出所料是个一眼题,T2 稍微画了画,把线路当成点,跑 floyd 是不是就做完了来着。

两个题写完差不多 15:00,感觉优势在我,遂开 T3。

注意到这个距离给的很没必要,等价于我们把 i 能走到最右端的点 R_i 给处理出来,那么 R_i 是单增的,这样我们就不需要原题面了。

然后考虑刻画最短路径为 2,感觉这个东西很难打成啊。

考虑把路径拆成三段,x \rightarrow X \rightarrow Y \rightarrow y,其中x \rightarrow X,Y \rightarrow y 这两段是唯一的,然后 X \rightarrow Y 有两种方案,且 Y=R_{R_X}。

注意到这个等价于,存在恰好两条 X \rightarrow Y 的路径,而且如果这个成立,那么这两条路径的形状一定是 X \rightarrow R_X \rightarrow Y 和 X \rightarrow R_X-1 \rightarrow Y。

欸这个很有道理对吧,写写写,怎么挂了第二个小样例。

R:[3,4,5,5,5]

仔细思考,原来是在 1 \rightarrow 3 的时候,若 Y=4,则 3 \rightarrow 5 的边被截断到 4,并且同样也满足条件。

然后场上,我做了做,觉得这个很不好统计,于是把以上思路推翻了。

但是,被我的思路一起推翻的,还有如上推论:

注意到这个等价于,存在恰好两条 X \rightarrow Y 的路径,而且如果这个成立,那么这两条路径的形状一定是 X \rightarrow R_X \rightarrow Y 和 X \rightarrow R_X-1 \rightarrow Y。

事实上这个东西,继续往后做,用桶+双指针维护,就是正解做法。但我场上不会维护这个,并且连着核心结论一起推翻了。(没记错的话好像是因为大样例在 WA,但大样例在 WA 不是因为这个原因。)

然后我当时考虑,是不是,distsum=2 的,对于一个 l 一定是一段区间,当然这个是假的。

又考虑,是不是容斥一下,对 distsum \le 2 的和 distsum = 1 的分别做,这两分别是一个区间,这个也是假完的,挂大样例了。

这个时候已经 16:40 了,严肃思考了 1min,感觉在这种还算重要的比赛里,all in 一个题是不算太对的策略,于是开 T4。

15pts 显然,然后考虑二分答案,那么问题转化成……

转化成啥啊!我咋完全不会刻画树上连通块!

看看特殊性质,这个 10pts 是不是白送的,先打了再说,测测测,过了大样例和我手打的几个数据,25pts 应该是有了。

回去开 T3,这个时候应该是 17:10 左右,首先把我的 O(n^3) 优化到了 O(n^2),具体就是考虑最短路的时候,只会被 \le 3 个点转移过去。

其实上面那个结论,就是被我推翻的那个结论的变体,但我场上并没有注意到。

特殊性质 A 是容易的,考虑 B 性质,对这个东西猜了一下结论,然后过了大样例,又手动构造了几个,改了几个 corner,不过也不确定最后是不是对的。

估分 100+100+48+25=273pts。

纵向对比,不如高一时的 304pts,甚至不如初三时的 290pts。

出考场之后问了一圈,发现 T3 好像是人均题,emo 了一段时间。

刷了刷讨论帖,怎么有人说要评蓝的?怎么还有一大堆同意的?这个时候大致观察了一下,听说最开始那个结论往下做是对的?

和一个比较好的朋友一块吃了个饭,聊了会天,不过不确定他有没有看出我的心不在焉。

回到家发了一些比较 emo 的话。

以下是总结。

事实上这场并没有犯那些对我来说,比较老生常谈的错误,比如死磕一个题而不打暴力,事实上最后留给我写暴力的时间还算充足。

那换句话说,就是,我总算得认识一个,更加核心更加本质的问题了。

在目前的训练水平下,很多时候,我的思考深度其实是没那么充足的,相对于思考广度来说。

最为典型的就是这一场的 T3,我在猜测的结论遇到一个稍微难以解决的问题后,并没有去枚举做法,或者用别的手段来解决,而是直接将结论全盘推翻去想别的做法。

其实这种行为,也算是早有预兆,就比如说,我的 Ad-hoc 水平还算可以,为什么呢,因为 Ad-hoc 的很多题恰好就是这样一种尝试的做法,往各个方面去试试就做出来了。包括一些结论题也是如此——这种做题方式很容易得到“第一个结论”。

再往前翻的话,其实也有好几场联考的题,我因为推翻了一个正确的结论而未能通过,或者说得到了一个正确的结论而不知道如何往下写;最为明显的便是在搜索和 DP 这几个算法上的短板。

可惜的是,在我意识到这一点的时候,距离 NOIP 只有不到一个月的时间。

幸好的是,在我意识到这一点的时候,距离 NOIP 还有将近一个月的时间。

No retreat,Stand last.